       subroutine thorpe(freq,alpha)
	  
c**********************************************************************
c      Thorpe attenuation
c      Written by Orlando Camargo Rodriguez
c      orodrig@ualg.pt
c      Universidade do Algarve
c      Physics Department
c      Signal Processing Laboratory
c      Faro, 02/08/2010 at 13:00
c****&******************************************************************
       
       real*8 alpha,freq,fxf
       
c***********************************************************************
       
c      Reference: Bellhop

       fxf   = ( freq/1000.0 )**2
       alpha = 0.0033 + 0.11*fxf/( 1.0 + fxf ) + 
     & 44.0*fxf/( 4100.0 + fxf ) + 0.0003*fxf
       alpha = alpha/8685.8896

       return 
       
       end
       
c***********************************************************************
